%{
#include <stdlib.h>  
char mystring[100];
char o='{';
char c='}';

//convert 0.2-0.3:
// change if a(2)=1 to if !a(2)...
// change a(2)=0 to a(2)=1
// change > to >=
// add 1 to for next loops with step >1 (maybe I won't bother with this)

//void yyerror(char *);  
%}    
%x ifbit
%x ifnotbit
%x andbit
%x andnotbit
%x orbit
%x ornotbit
%x bit
%%    
[ \t]+ putchar(' ');
[ \t\r]+$

"!collision" printf("collision");
"collision" printf("!collision");

"if "[A-Za-z]+"(" {strcpy(mystring,yytext);mystring[strlen(mystring)-1]=o;BEGIN(ifbit);}
<ifbit>[0-5] printf("if !%s%s",mystring+3,yytext);
<ifbit>[6-7] printf("%s%s",mystring,yytext);
<ifbit>")" {printf("%c",c);BEGIN(INITIAL);}

"if !"[A-Za-z]+"(" {strcpy(mystring,yytext);mystring[strlen(mystring)-1]=o;BEGIN(ifnotbit);}
<ifnotbit>[0-5] mystring[3]=' ';printf("%s%s",mystring,yytext);
<ifnotbit>[6-7] printf("%s%s",mystring,yytext);
<ifnotbit>")" {printf("%c",c);BEGIN(INITIAL);}

"|| "[A-Za-z]+"(" {strcpy(mystring,yytext);mystring[strlen(mystring)-1]=o;BEGIN(orbit);}
<orbit>[0-5] printf("if !%s%s",mystring+3,yytext);
<orbit>[6-7] printf("%s%s",mystring,yytext);
<orbit>")" {printf("%c",c);BEGIN(INITIAL);}

"|| !"[A-Za-z]+"(" {strcpy(mystring,yytext);mystring[strlen(mystring)-1]=o;BEGIN(ornotbit);}
<ornotbit>[0-5] mystring[3]=' ';printf("%s%s",mystring,yytext);
<ornotbit>[6-7] printf("%s%s",mystring,yytext);
<ornotbit>")" {printf("%c",c);BEGIN(INITIAL);}

"&& "[A-Za-z]+"(" {strcpy(mystring,yytext);mystring[strlen(mystring)-1]=o;BEGIN(andbit);}
<andbit>[0-5] printf("if !%s%s",mystring+3,yytext);
<andbit>[6-7] printf("%s%s",mystring,yytext);
<andbit>")" {printf("%c",c);BEGIN(INITIAL);}

"&& !"[A-Za-z]+"(" {strcpy(mystring,yytext);mystring[strlen(mystring)-1]=o;BEGIN(andnotbit);}
<andnotbit>[0-5] mystring[3]=' ';printf("%s%s",mystring,yytext);
<andnotbit>[6-7] printf("%s%s",mystring,yytext);
<andnotbit>")" {printf("%c",c);BEGIN(INITIAL);}

[A-Za-z]+"(" {strcpy(mystring,yytext);mystring[strlen(mystring)-1]=o;BEGIN(bit);}
<bit>"0)"[ ]+"="[ ]+"0" {printf("%s0%c = 0",mystring,c);BEGIN(INITIAL);}
<bit>"0)"[ ]+"="[ ]+"1" {printf("%s0%c = 1",mystring,c);BEGIN(INITIAL);}
<bit>"1)"[ ]+"="[ ]+"0" {printf("%s1%c = 0",mystring,c);BEGIN(INITIAL);}
<bit>"1)"[ ]+"="[ ]+"1" {printf("%s1%c = 1",mystring,c);BEGIN(INITIAL);}
<bit>"2)"[ ]+"="[ ]+"0" {printf("%s2%c = 0",mystring,c);BEGIN(INITIAL);}
<bit>"2)"[ ]+"="[ ]+"1" {printf("%s2%c = 1",mystring,c);BEGIN(INITIAL);}
<bit>"3)"[ ]+"="[ ]+"0" {printf("%s3%c = 0",mystring,c);BEGIN(INITIAL);}
<bit>"3)"[ ]+"="[ ]+"1" {printf("%s3%c = 1",mystring,c);BEGIN(INITIAL);}
<bit>"4)"[ ]+"="[ ]+"0" {printf("%s4%c = 0",mystring,c);BEGIN(INITIAL);}
<bit>"4)"[ ]+"="[ ]+"1" {printf("%s4%c = 1",mystring,c);BEGIN(INITIAL);}
<bit>"5)"[ ]+"="[ ]+"0" {printf("%s5%c = 0",mystring,c);BEGIN(INITIAL);}
<bit>"5)"[ ]+"="[ ]+"1" {printf("%s5%c = 1",mystring,c);BEGIN(INITIAL);}
<bit>"6)"[ ]+"="[ ]+"0" {printf("%s6%c = 0",mystring,c);BEGIN(INITIAL);}
<bit>"6)"[ ]+"="[ ]+"1" {printf("%s6%c = 1",mystring,c);BEGIN(INITIAL);}
<bit>"7)"[ ]+"="[ ]+"0" {printf("%s7%c = 0",mystring,c);BEGIN(INITIAL);}
<bit>"7)"[ ]+"="[ ]+"1" {printf("%s7%c = 1",mystring,c);BEGIN(INITIAL);}

"<>" printf("<>");
">" printf(">=");

[A-Z]+ printf("%s",yytext);
[a-z]+       {       printf("%s", yytext);}
[0-9]+      {       printf("%s", yytext);}
[\n] {printf("\n");}
.      {       printf("%s", yytext);}
%%
  int yywrap(void) {      return 1;  } 
main(){yylex();}
